import { QuestionCircleOutlined } from "@ant-design/icons";
import { Button, Popconfirm } from "antd";
import axios from "axios";
import { useState } from "react";
import { useTranslation } from "react-i18next";
import { logImEXEvent } from "../../firebase/firebase.utils";
import { useNotification } from "../../contexts/Notifications/notificationContext.jsx";
/*
################################################################################################
 Developer Note:
 Known Technical Debt Item
         Modifications to this code requires complementary changes to the Imgproxy code. This code will be removed once the imgproxy migration is completed.
################################################################################################
*/
export default function JobsDocumentsDeleteButton({ galleryImages, deletionCallback }) {
  const { t } = useTranslation();
  const notification = useNotification();

  const imagesToDelete = [
    ...galleryImages.images.filter((image) => image.isSelected),
    ...galleryImages.other.filter((image) => image.isSelected)
  ];
  const [loading, setLoading] = useState(false);

  const handleDelete = async () => {
    logImEXEvent("job_documents_delete", { count: imagesToDelete.length });
    setLoading(true);
    const res = await axios.post("/media/delete", {
      ids: imagesToDelete
    });

    if (res.data.error) {
      notification.error({
        title: t("documents.errors.deleting", {
          error: JSON.stringify(res.data.error.response.errors)
        })
      });
    } else {
      notification.success({
        key: "docdeletedsuccesfully",
        title: t("documents.successes.delete")
      });

      if (deletionCallback) deletionCallback();
    }

    setLoading(false);
  };

  return (
    <Popconfirm
      disabled={imagesToDelete.length < 1}
      icon={<QuestionCircleOutlined style={{ color: "red" }} />}
      onConfirm={handleDelete}
      title={t("documents.labels.confirmdelete")}
      okText={t("general.actions.delete")}
      okButtonProps={{ type: "danger" }}
      cancelText={t("general.actions.cancel")}
    >
      <Button disabled={imagesToDelete.length < 1} loading={loading}>
        {t("documents.actions.delete")}
      </Button>
    </Popconfirm>
  );
}
